theory ex1
imports 
  "../tools/Hoare/Vcg"
  "../tools/Hoare/HeapList"
  "../llverification/libHoare/in_range"
begin


record "globals" =
alloc_' :: "ref list"
free_' :: "nat"

--"GLOBAL VARIABLES"
g'N_' :: "nat"
g'sum_' :: "nat"
g'max_' :: "nat"

--"LOCAL VARIABLES / PARAMETERS / RETURN RESULTS"
record 'g vars = "'g state" +
l'sum_and_max'a_' :: "nat list"
l'sum_and_max'i_' :: "nat"
res'int_' :: "int"



procedures
  sum_and_max(l'sum_and_max'a | res'int)  =  "
  \<acute>g'sum :==\<^sub>g (0::nat);;
  \<acute>g'max :==\<^sub>g (0::nat);;
  \<acute>l'sum_and_max'i :==\<^sub>g (0::nat);;
  WHILE\<^sub>g \<acute>l'sum_and_max'i < \<acute>g'N DO
    IF\<^sub>g \<acute>g'max < \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i) THEN
      \<acute>g'max :==\<^sub>g \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i)
    FI;;
    \<acute>g'sum :==\<^sub>g \<acute>g'sum + \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i);;
    \<acute>l'sum_and_max'i :==\<^sub>g \<acute>l'sum_and_max'i + (1::nat)
  OD;;
  \<acute>res'int :==\<^sub>g (0::int)"


axioms always_in_range[simp]: "in_range a"

lemma sum_base[rule_format]: "! a. a + foldl op + (0::nat) xs = foldl op + a xs"
apply (induct xs, simp_all)
apply clarsimp
apply (rule_tac s = "aa + a + foldl op + 0 xs" in trans)
 apply (simp (no_asm))
 apply simp_all
done

lemma sum_take_Suc: 
  "i < length ls \<Longrightarrow> foldl op + (0::nat) (take (Suc i) ls) = foldl op + 0 (take i ls) + ls ! i"
apply (subst take_Suc_conv_app_nth)
 apply simp
apply (subst foldl_append)
apply (cut_tac a = "foldl op + 0 (take i ls)" in sum_base)
apply (erule subst)
apply simp
done


lemma (in sum_and_max_impl) sum_and_max_spec:
shows
   "\<forall>\<sigma>. \<Gamma>\<turnstile>\<^sub>t 
  
  \<lbrace>\<sigma>. length \<^bsup>\<sigma>\<^esup>l'sum_and_max'a = \<^bsup>\<sigma>\<^esup>g'N \<rbrace> 

  \<acute>res'int :== PROC sum_and_max(\<acute>l'sum_and_max'a) 

  \<lbrace> \<acute>g'sum \<le> \<^bsup>\<sigma>\<^esup>g'N * \<acute>g'max \<rbrace>"
apply (hoare_rule HoareTotal.ProcNoRec1)
apply (hoare_rule anno = "
  \<acute>g'sum :==\<^sub>g (0::nat);;
  \<acute>g'max :==\<^sub>g (0::nat);;
  \<acute>l'sum_and_max'i :==\<^sub>g (0::nat);;
  WHILE\<^sub>g \<acute>l'sum_and_max'i < \<acute>g'N
    INV \<lbrace> length \<acute>l'sum_and_max'a = \<^bsup>\<sigma>\<^esup>g'N
  \<and> \<acute>l'sum_and_max'i \<le> \<acute>g'N
  \<and> (\<forall> i < \<acute>l'sum_and_max'i. \<acute>l'sum_and_max'a ! i \<le> \<acute>g'max) 
  \<and> \<acute>g'sum = foldl (op +) 0 (take \<acute>l'sum_and_max'i \<acute>l'sum_and_max'a)
  \<and> \<acute>g'sum \<le> \<acute>l'sum_and_max'i * \<acute>g'max
  \<and> \<acute>g'N = \<^bsup>\<sigma>\<^esup>g'N \<rbrace>
    VAR MEASURE (\<^bsup>\<sigma>\<^esup>g'N - \<acute>l'sum_and_max'i)
  DO
    IF\<^sub>g \<acute>g'max < \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i) THEN
      \<acute>g'max :==\<^sub>g \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i)
    FI;;
    \<acute>g'sum :==\<^sub>g \<acute>g'sum + \<acute>l'sum_and_max'a!(\<acute>l'sum_and_max'i);;
    \<acute>l'sum_and_max'i :==\<^sub>g \<acute>l'sum_and_max'i + (1::nat)
  OD;;
  \<acute>res'int :==\<^sub>g (0::int)
  " in HoareTotal.annotateI)
apply vcg
apply (auto simp add: sum_take_Suc)
    apply arith
   apply (case_tac "i = l'sum_and_max'i", simp_all)
   apply (erule_tac x = "i" in allE)
   apply simp
  apply (erule le_trans)
  apply simp
 apply arith
apply (case_tac "i = l'sum_and_max'i", simp_all)
done

end