
class MaxSum {

   int sum;
   int max;
   
   /*@ public normal_behaviour
     @   requires (\forall int i; 0<=i && i < a.length; a[i] >= 0);
     @   ensures (\forall int i; 0<=i && i < a.length; max >= a[i]);
     @   ensures (a.length > 0 ==>
     @         (\exists int i; 0<=i && i < a.length; max == a[i]));
     @   ensures sum == (\sum int i; 0<= i && i < a.length; a[i]);
     @   ensures sum <= a.length * max;
     @*/
   void sumAndMax(int[] a) {
      sum = 0;
      max = 0;
      int k = 0;
      
      /*@ loop_invariant
        @     (\forall int i; 0<=i && i < k; max >= a[i])
        @  && (k > 0 ==> (\exists int i; 0<=i && i < k; max == a[i]))
        @  && sum == (\bsum int i; 0; k; a[i])
        @  && sum <= k * max
        @  && 0 <= k && k <= a.length
        @  && (k == 0 ==> max == 0);
        @ 
        @  decreases a.length - k;
        @  modifies max, sum, k;
        @*/
      while(k < a.length){
         if (max < a[k]){
            max = a[k];
         }
         sum += a[k];
         k++;
      }
    }
}
