-- Main program for the Sum_Max problem.
--
-- Note that this procedure is written in Ada, not SPARK!
-- It's much easier to do I/O that way...

with SM;
with Ada.Text_IO; use Ada.Text_IO;
procedure Main
is
   subtype Index_1 is SM.Index range 1 .. 1;
   subtype Index_2 is SM.Index range 1 .. 2;
   subtype Index_10 is SM.Index range 1 .. 10;
   subtype Index_Max is SM.Index;

   subtype Vector_1 is SM.Vector (Index_1);
   subtype Vector_2 is SM.Vector (Index_2);
   subtype Vector_10 is SM.Vector (Index_10);
   subtype Vector_Max is SM.Vector (Index_Max);

   -- T1 - Base test case - vector with only 1 element.
   -- Sum and Max are both 3
   T1  : constant Vector_1 := Vector_1'(1 => 3);

   -- T2 - First interesting test case - vector with
   -- 2 elements.

   -- T2a - Max is the _second_ element = 9.  Sum is 13.
   T2a : constant Vector_2 := Vector_2'(4, 9);

   -- T2b - Max is the _first_ element = 99.  Sum is 131.
   T2b : constant Vector_2 := Vector_2'(99, 32);

   -- T3 - test case specified in problem specification.  Sum is 45, Max is 10
   T3 : constant Vector_10 := Vector_10'(9, 5, 0, 2, 7, 3, 2, 1, 10, 6);

   -- T4 - boundary case - maximum number of elements, all maximum value.
   -- Sum should be (SM.Max_Value * SM.Max_Index). Max is SM.Max_Value
   T4 : constant Vector_Max := Vector_Max'(others => SM.Max_Value);

   Sum : SM.Sum_Range;
   Max : SM.Value;
begin
   Put_Line ("Test T1");
   SM.Sum_Max (T1, Sum, Max);
   Put_Line ("Sum is" & Sum'Img);
   Put_Line ("Max is" & Max'Img);
   New_Line;

   Put_Line ("Test T2a");
   SM.Sum_Max (T2a, Sum, Max);
   Put_Line ("Sum is" & Sum'Img);
   Put_Line ("Max is" & Max'Img);
   New_Line;

   Put_Line ("Test T2b");
   SM.Sum_Max (T2b, Sum, Max);
   Put_Line ("Sum is" & Sum'Img);
   Put_Line ("Max is" & Max'Img);
   New_Line;

   Put_Line ("Test T3");
   SM.Sum_Max (T3, Sum, Max);
   Put_Line ("Sum is" & Sum'Img);
   Put_Line ("Max is" & Max'Img);
   New_Line;

   Put_Line ("Test T4");
   SM.Sum_Max (T4, Sum, Max);
   Put_Line ("Sum is" & Sum'Img);
   Put_Line ("Max is" & Max'Img);

end Main;
