#include "vcc.h"
#include "limits.h"

unsigned sum_max(unsigned *a, unsigned N, unsigned *maxout spec(out unsigned S[unsigned]))
  requires(wrapped(as_array(a, N)))
  ensures(forall(unsigned k; k<N; S[k + 1] == S[k] + a[k]))
  ensures(result == S[N])
  writes(maxout)
  ensures(forall(unsigned k; k<N; *maxout>=a[k]))
  ensures(N * *maxout >= result)
{
  unsigned max;
  unsigned sum = 0;
  unsigned i;

  //spec(unsigned oldmax = 0;)
  spec(unsigned maxsum = 0;)

  spec(S = lambda(unsigned k; (unsigned)0);)  

  for (i=0; i<N; i++)
      invariant(forall(unsigned k; k<i; S[k + 1] == S[k] + a[k]))
      invariant(sum == S[i])     
      invariant(forall(unsigned k; k<i; max>=a[k]))
      invariant(maxsum >= sum)
      invariant(maxsum <= i * max)
      invariant(i*max >= sum)
      invariant(i <= N)
  { 
      assert(i<N);
      //spec(oldmax = max;)
      if (max < a[i])
          max = a[i];
assume(maxsum + max < UINT_MAX); // satisfy overflow check
      //assert(maxsum <= i * oldmax );
      //assert(oldmax <= max);
assume(maxsum <= i * max );
    
      spec(maxsum += max;)
      sum += a[i];
      spec(S[i+1] = S[i] + a[i];)   
  }

  assert(sum == S[N]);
  *maxout = max;
  return sum;
}