theory ex3
imports 
  "../tools/Hoare/Vcg"
  "../tools/Hoare/HeapList"
  "../llverification/libHoare/in_range"
begin


record "globals" =
alloc_' :: "ref list"
free_' :: "nat"

--"HEAP FUNCTIONS"
ref'list_el'val_' :: "ref \<Rightarrow> int"
ref'list_el'next_' :: "ref \<Rightarrow> ref"

--"LOCAL VARIABLES / PARAMETERS / RETURN RESULTS"
record 'g vars = "'g state" +
l'first_zero_elem'head_' :: "ref"
l'first_zero_elem'jj_' :: "ref"
l'first_zero_elem'i_' :: "nat"
res'nat_' :: "nat"


--"PROCEDURES"


procedures
  first_zero_elem(l'first_zero_elem'head | res'nat)  =  "
  \<acute>l'first_zero_elem'i :==\<^sub>g (0::nat);;
  \<acute>l'first_zero_elem'jj :==\<^sub>g \<acute>l'first_zero_elem'head;;
  WHILE\<^sub>g \<acute>l'first_zero_elem'jj \<noteq> Null \<and> (\<acute>l'first_zero_elem'jj \<rightarrow> \<acute>ref'list_el'val) \<noteq> (0::int) DO
    \<acute>l'first_zero_elem'jj :==\<^sub>g (\<acute>l'first_zero_elem'jj \<rightarrow> \<acute>ref'list_el'next);;
    \<acute>l'first_zero_elem'i :==\<^sub>g \<acute>l'first_zero_elem'i + 1
  OD;;
  \<acute>res'nat :==\<^sub>g \<acute>l'first_zero_elem'i"


axioms always_in_range[simp]: "in_range a"
declare drop_drop [simp del]

lemma (in first_zero_elem_impl) first_zero_elem_spec:
shows
   "\<forall>\<sigma> Ps. \<Gamma>\<turnstile>\<^sub>t 
  
  \<lbrace>\<sigma>. List \<^bsup>\<sigma>\<^esup>l'first_zero_elem'head \<^bsup>\<sigma>\<^esup>ref'list_el'next Ps \<rbrace> 

  \<acute>res'nat :== PROC first_zero_elem(\<acute>l'first_zero_elem'head) 

  \<lbrace> ((\<forall> i<length Ps. (Ps ! i)\<rightarrow> \<^bsup>\<sigma>\<^esup>ref'list_el'val \<noteq> 0) 
              \<longrightarrow> \<acute>res'nat = length Ps) 
  \<and> ((\<exists> i<length Ps. (Ps ! i)\<rightarrow> \<^bsup>\<sigma>\<^esup>ref'list_el'val = 0) 
              \<longrightarrow> (Ps ! \<acute>res'nat)\<rightarrow> \<^bsup>\<sigma>\<^esup>ref'list_el'val = 0 \<and> (\<forall> i<\<acute>res'nat. (Ps ! i)\<rightarrow> \<^bsup>\<sigma>\<^esup>ref'list_el'val \<noteq> 0)) \<rbrace>"
apply (hoare_rule HoareTotal.ProcNoRec1)
apply (hoare_rule anno = "
  \<acute>l'first_zero_elem'i :==\<^sub>g (0::nat);;
  \<acute>l'first_zero_elem'jj :==\<^sub>g \<acute>l'first_zero_elem'head;;
  WHILE\<^sub>g \<acute>l'first_zero_elem'jj \<noteq> Null \<and> (\<acute>l'first_zero_elem'jj \<rightarrow> \<acute>ref'list_el'val) \<noteq> (0::int) 
    INV \<lbrace> List \<acute>l'first_zero_elem'jj \<^bsup>\<sigma>\<^esup>ref'list_el'next (drop \<acute>l'first_zero_elem'i Ps)
  \<and> \<acute>l'first_zero_elem'i \<le> length Ps
  \<and> (\<forall> i < \<acute>l'first_zero_elem'i. (Ps ! i)\<rightarrow> \<acute>ref'list_el'val \<noteq> 0)
  \<and> \<acute>ref'list_el'next = \<^bsup>\<sigma>\<^esup>ref'list_el'next
  \<and> \<acute>ref'list_el'val = \<^bsup>\<sigma>\<^esup>ref'list_el'val \<rbrace>
    VAR MEASURE (length Ps - \<acute>l'first_zero_elem'i)
  DO
    \<acute>l'first_zero_elem'jj :==\<^sub>g (\<acute>l'first_zero_elem'jj \<rightarrow> \<acute>ref'list_el'next);;
    \<acute>l'first_zero_elem'i :==\<^sub>g \<acute>l'first_zero_elem'i + 1
  OD;;
  \<acute>res'nat :==\<^sub>g \<acute>l'first_zero_elem'i" in HoareTotal.annotateI)
apply vcg

apply simp

apply simp
apply (elim exE conjE)
apply clarsimp
apply (rule conjI)
 apply (subgoal_tac "l'first_zero_elem'i < length Ps")
  apply arith
 apply (rule ccontr)
 apply simp
apply (rule conjI)
 apply (cut_tac drop_drop[of 1, simplified])
 apply (rotate_tac -1, erule subst)
 apply simp
apply (rule conjI)
 apply (subgoal_tac "l'first_zero_elem'i < length Ps")
  apply arith
 apply (rule ccontr)
 apply simp
apply clarsimp
apply (case_tac "i = l'first_zero_elem'i")
 apply (case_tac "l'first_zero_elem'i = length Ps")
  apply simp
 apply (cut_tac i = l'first_zero_elem'i and xs = Ps in drop_Suc_conv_tl)
  apply simp
 apply (rotate_tac -1, drule sym)
 apply simp
apply simp

apply simp
apply (intro conjI impI)
 apply simp
 apply (erule disjE, simp)
 apply (rule ccontr)
 apply (cut_tac i = l'first_zero_elem'i and xs = Ps in drop_Suc_conv_tl)
  apply simp
 apply (rotate_tac -1, drule sym)
 apply simp
apply (drule disjE, simp_all)
 apply (elim exE conjE)
 apply (erule_tac x = "i" in allE)
 apply simp
apply (elim conjE exE)
apply (case_tac "l'first_zero_elem'i = length Ps", simp_all)
apply (cut_tac i = l'first_zero_elem'i and xs = Ps in drop_Suc_conv_tl)
 apply arith
apply (rotate_tac -1, drule sym)
apply simp
done

end