theory ex3
imports 
  "../tools/Hoare/Vcg"
  "../tools/Hoare/HeapList"
  "../llverification/libHoare/in_range"
begin


record "globals" =
alloc_' :: "ref list"
free_' :: "nat"

--"HEAP FUNCTIONS"
val_' :: "ref -> int"
next_' :: "ref -> ref"

--"LOCAL VARIABLES / PARAMETERS / RETURN RESULTS"
record 'g vars = "'g state" +
head_' :: "ref"
jj_' :: "ref"
i_' :: "nat"
res'nat_' :: "nat"


--"PROCEDURES"


procedures
  first_zero_elem(head | res'nat)  =  "
  i :== (0::nat);;
  jj :== head;;
  WHILE jj  !=  Null \<and> (jj -> val)  !=  (0::int) DO
    jj :== (jj -> next);;
    i :== i + 1
  OD;;
  res'nat :== i"


axioms always_in_range[simp]: "in_range a"
declare drop_drop [simp del]

lemma (in first_zero_elem_impl) first_zero_elem_spec:
shows
   "\<forall> Ps. \<Gamma>\<turnstile>\<^sub>t 
  
  \<lbrace>\<sigma>. List head0 next0 Ps \<rbrace> 

  res'nat :== PROC first_zero_elem(head) 

  \<lbrace> ((\<forall> i<length Ps. (Ps ! i)-> val0  !=  0) 
              \<longrightarrow> res'nat = length Ps) 
  \<and> ((\<exists> i<length Ps. (Ps ! i)-> val0 = 0) 
              \<longrightarrow> (Ps ! res'nat)-> val0 = 0 \<and> (\<forall> i<res'nat. (Ps ! i)-> val0  !=  0)) \<rbrace>"
apply (hoare_rule HoareTotal.ProcNoRec1)
apply (hoare_rule anno = "
  i :== (0::nat);;
  jj :== head;;
  WHILE jj  !=  Null \<and> (jj -> val)  !=  (0::int) 
    INV \<lbrace> List jj next0 (drop i Ps)
  \<and> i \<le> length Ps
  \<and> (\<forall> i < i. (Ps ! i)-> val  !=  0)
  \<and> next = next0
  \<and> val = val0 \<rbrace>
    VAR MEASURE (length Ps - i)
  DO
    jj :== (jj -> next);;
    i :== i + 1
  OD;;
  res'nat :== i" in HoareTotal.annotateI)
apply vcg

apply simp

apply simp
apply (elim exE conjE)
apply clarsimp
apply (rule conjI)
 apply (subgoal_tac "i < length Ps")
  apply arith
 apply (rule ccontr)
 apply simp
apply (rule conjI)
 apply (cut_tac drop_drop[of 1, simplified])
 apply (rotate_tac -1, erule subst)
 apply simp
apply (rule conjI)
 apply (subgoal_tac "i < length Ps")
  apply arith
 apply (rule ccontr)
 apply simp
apply clarsimp
apply (case_tac "i = i")
 apply (case_tac "i = length Ps")
  apply simp
 apply (cut_tac i = i and xs = Ps in drop_Suc_conv_tl)
  apply simp
 apply (rotate_tac -1, drule sym)
 apply simp
apply simp

apply simp
apply (intro conjI impI)
 apply simp
 apply (erule disjE, simp)
 apply (rule ccontr)
 apply (cut_tac i = i and xs = Ps in drop_Suc_conv_tl)
  apply simp
 apply (rotate_tac -1, drule sym)
 apply simp
apply (drule disjE, simp_all)
 apply (elim exE conjE)
 apply (erule_tac x = "i" in allE)
 apply simp
apply (elim conjE exE)
apply (case_tac "i = length Ps", simp_all)
apply (cut_tac i = i and xs = Ps in drop_Suc_conv_tl)
 apply arith
apply (rotate_tac -1, drule sym)
apply simp
done

end
