function IsConsistent(N: int, board: seq<int>, pos: int): bool
;  // TODO
/*
  requires 0 <= pos && pos <= N && |board| <= pos;
{
  (forall q :: 0 <= q && q < pos ==>
    board[q] != board[pos] &&
    board[q] - board[pos] != pos - q &&
    board[pos] - board[q] != pos - q)
}
*/

method CheckConsistent(N: int, board: seq<int>, pos: int) returns (b: bool)
  ensures b <==> IsConsistent(N, board, pos);
{
  assume false;  // TODO
}

function AllConsistent(N: int, board: seq<int>): bool
{
  N == |board| &&
  (forall k :: 0 <= k && k < N ==> IsConsistent(N, board, k))
}

function witness(m: int, B: seq<int>): bool { true }

method Search(N: int, boardSoFar: seq<int>) returns (success: bool, newBoard: seq<int>)
  requires 0 <= N && |boardSoFar| <= N;
  requires (forall k :: 0 <= k && k < |boardSoFar| ==> IsConsistent(N, boardSoFar, k));
  ensures success ==> AllConsistent(N, newBoard);
  ensures !success ==> (exists m, B :: 0 <= m && m < N && boardSoFar <= B && |B| <= N &&
                         witness(m,B) &&
                         (forall k :: 0 <= k && k < |B| ==> IsConsistent(N, B, k)) &&
                         (forall p :: 0 <= p && p < N ==> !IsConsistent(N, B+[p], m+1)));
  decreases N - |boardSoFar|;
{
  var pos := |boardSoFar|;
  if (pos == N) {
    newBoard := boardSoFar;
    success := true;
  } else {
    var i := 0;
    while (i < N)
      invariant i <= N;
/* TODO
      invariant 1 <= N ==>
          (forall k :: 0 <= k && k < |boardSoFar| ==> IsConsistent(N, boardSoFar, k)) &&
          (forall p :: 0 <= p && p < i ==> !IsConsistent(N, boardSoFar+[p], pos+1));
*/
    {
      var candidateBoard := boardSoFar + [i];
      assert |candidateBoard| == pos + 1;
      call consistent := CheckConsistent(N, candidateBoard, pos+1);
      if (consistent) {
        // assume (forall k :: 0 <= k && k < |boardSoFar| ==> IsConsistent(N, boardSoFar, k) ==> IsConsistent(N, candidateBoard, k));  // TODO
        assume (forall k :: 0 <= k && k < |candidateBoard| ==> IsConsistent(N, candidateBoard, k));  // TODO
        call s, b := Search(N, candidateBoard);
        if (s) {
          newBoard := b;
          success := true;
          return;
        }
      }
      i := i + 1;
    }

    assert witness(pos, boardSoFar);
    assume (forall p :: 0 <= p && p < N ==> !IsConsistent(N, boardSoFar+[p], pos+1));  // TODO

    success := false;
  }
}

method Main()
{
  call s, b := Search(2, []);
  print "N=2 returns ", s, "\n";
  call s, b := Search(4, []);
  print "N=4 returns ", s, "\n";
  call PrintSeq(b);
}

method PrintSeq(b: seq<int>)
{
  var i := 0;
  while (i < |b|) {
    print "  ", b[i], "\n";
    i := i + 1;
  }
}

