class Node {
    int head;
    Node next;
    int length;
    
    Node()
        //@ requires true;
        //@ ensures List(this, nil);
    {
    }
    
    int getLength()
        //@ requires [?f]List(this, ?elems);
        //@ ensures [f]List(this, elems) &*& result == length(elems);
    {
        int x = length;
        //@ close [f]List(this, elems);
        return x;
    }
    
    Node Cons(int x)
        //@ requires [_]List(this, ?elems);
        //@ ensures [_]List(result, cons(x, elems)) &*& result != null;
    {
        Node n = new Node();
        n.head = x;
        n.next = this;
        n.length = this.getLength() + 1;
        //@ close List(n, cons(x, elems));
        return n;
    }
    
    static void Test() // Illustrates sharing.
        //@ requires true;
        //@ ensures true;
    {
        Node x = new Node();
        x = x.Cons(10);
        x = x.Cons(20);
        Node y = x.Cons(30);
        Node z = x.Cons(40);
    }
}

/*@

predicate List(Node n; list<int> elems) =
    n.head |-> ?head &*&
    n.next |-> ?next &*&
    (next == null ?
        elems == nil
    :
        [_]List(next, ?tail) &*&
        elems == cons(head, tail)) &*&
    n.length |-> ?length &*&
    length == length(elems);

@*/
